//////////////////////////////////////////////////////////
//
// synthetic test scenes for
// structured light survey
// 
// christoph schmalz
// 2009
//
// christoph(a)structuredlightsurvey.de
//
//////////////////////////////////////////////////////////
//
// version 1.0 - first public release
//
//////////////////////////////////////////////////////////
//
// xyz axes for better orientation
//
// from stefan lohmueller
// http://www.lohmueller.business.t-online.de/pov_tut/pov__eng.htm
//
//////////////////////////////////////////////////////////

//---------------------------------------------------------------------
#macro Axis_( AxisLen, RedTexture, WhiteTexture )
union{
    cylinder {<0,-AxisLen,0>,<0,AxisLen,0>,0.05
              texture{checker texture{RedTexture} texture{WhiteTexture}
                      translate<0.1,0,0.1>}}
    cone{<0,AxisLen,0>,0.2,<0,AxisLen+0.7,0>,0
         texture{RedTexture}}

    no_shadow
    finish { ambient 1 }
	}                  
#end // of macro Axis (AxisLen)
//----------------------------------------------------------------------

//----------------------------------------------------------------------
#macro AxesXYZ_( AxisLenX, AxisLenY, AxisLenZ, TexRed, TexWhite)
union{
object{Axis_(AxisLenX, TexRed, TexWhite)   rotate< 0,0,-90>}   // x-Axis
object{Axis_(AxisLenY, TexRed, TexWhite)   rotate< 0,0,  0>}   // y-Axis
object{Axis_(AxisLenZ, TexRed, TexWhite)   rotate<90,0,  0>}   // z-Axis
text{ttf"arial.ttf",  "x",  0.15,  0
     texture{TexRed} 
     scale 0.5 translate <AxisLenX+0.05,0.4,-0.12>
     no_shadow}
text{ttf"arial.ttf",  "y",  0.15,  0  
     texture{TexRed} 
     scale 0.5 translate <-0.85,AxisLenY+0.50,-0.05>
     no_shadow}
text{ttf"arial.ttf",  "z",  0.15,  0
     texture{TexRed} 
     scale 0.5 translate <-0.75,0.2,AxisLenZ+0.50>
     no_shadow}
} // end of union
#end// of macro "AxesXYZ(...)"
//----------------------------------------------------------------------

//--------------------------drawing the axes ----
#declare Tex_Dark =  texture{ pigment{ color rgb<1,0.35,0>}
                              finish { phong 1}}
#declare Tex_White = texture{ pigment{ color rgb<1,1,1>}
                              finish { phong 1}}

#macro Axes( scalefactor, position )
object{ 
	AxesXYZ_( 3, 3, 3, Tex_Dark, Tex_White)
	scale scalefactor
	translate position
}
#end
//----------------------------------------------------------------------