//////////////////////////////////////////////////////////
//
// synthetic test scenes for
// structured light survey
// 
// christoph schmalz
// 2009
//
// christoph(a)structuredlightsurvey.de
//
//////////////////////////////////////////////////////////
//
// version 1.0 - first public release
//
//////////////////////////////////////////////////////////
//
// includes the dragon mesh or an impostor object for speed
// taken from http://www.cc.gatech.edu/projects/large_models/
// converted to povray format with poseray
//
// object will be located in a unit box centered at zero
//
//////////////////////////////////////////////////////////

#macro dragon(TEST)

	#if (TEST=1)
		#declare impostor = object {
			box {
				//these numbers come from the header of the .inc below
				//cannot include it, else we lose the speed advantage ...
				<-0.108323,0.0527295,-0.0504143>,<0.0965662,0.197173,0.0412075>
				pigment { color rgbt 0.5 }
				finish { specular 0.6 }
			}
		}
		
		#local Min = min_extent ( impostor );
		#local Max = max_extent ( impostor );
		#local Size = Max-Min;
	
		object {
			impostor
			hollow
			translate -Min
			translate -Size/2
			scale 1/max(Size.x,Size.y,Size.z)
			}
		
	#else
	
		#include "dragon_vrip_POV_geom.inc" //Geometry
	
		#local Min = min_extent ( dragon_vrip_ );
		#local Max = max_extent ( dragon_vrip_ );
		#local Size = Max-Min;
	
		//Assembled object that is contained in dragon_vrip_POV_geom.inc
		object {
	    	dragon_vrip_
	    	hollow
			translate -Min
			translate -Size/2
			scale 1/max(Size.x,Size.y,Size.z)
			}
	#end

#end