//////////////////////////////////////////////////////////
//
// synthetic test scenes for
// structured light survey
// 
// christoph schmalz
// 2009
//
// christoph(a)structuredlightsurvey.de
//
//////////////////////////////////////////////////////////
//
// version 1.0 - first public release
//
//////////////////////////////////////////////////////////
//
// includes a keyboard mesh
//
// model originally created by hans kollhoff
// http://www.archibaseplanet.com/download/12164.html
// converted to povray format with poseray
//
//////////////////////////////////////////////////////////

//object is located in a unit box centered at zero
#macro keyboard(color1,color2,useMaterial)
	
		#include "Keyboard_POV_geom.inc" //Geometry

		#local bodyMaterial = 
		material{
		texture{ pigment {color rgb color1 transmit  0}
				normal { granite 0.1 scale 0.0005 } //original mesh is very small
		        finish{specular 0.8980392 roughness 0.3843412 ambient 0.4 diffuse 0.2 conserve_energy}}
		}
		#local letterMaterial = 
		material{
		texture{ pigment {color rgb color2 transmit  0} 
		        finish{specular 0.1980392 roughness 0.0843412 ambient 0.4 diffuse 0.2 conserve_energy}}
		}
		
		#if (useMaterial)
			#local Keyboard_N031107_=
			union {
				object{Keyboard_ material{letterMaterial} hollow}
				object{Keyboard_Body_ material{bodyMaterial} hollow}
			}
		#else
			#local Keyboard_N031107_=
			union {
				object{Keyboard_ hollow}
				object{Keyboard_Body_ hollow}
			}
		#end

		#local Min = min_extent ( Keyboard_N031107_ );
		#local Max = max_extent ( Keyboard_N031107_ );
		#local Size = Max-Min;

		union {
			object {
		    	Keyboard_N031107_
		    	hollow
				translate -Min
				translate -Size/2
				scale 1/max(Size.x,Size.y,Size.z)
				}

			//need something to plug the holes
			box { <-0.10,-0.03,-0.49> <0.21,-0.029,0.47>
					#if (useMaterial)
						pigment { color rgb 0 }
					#end
					rotate -y*5
				}

	    	matrix < 1,0,0, 0,0,1, 0,1,0, 0,0,0 > //convert from righthanded ...
		}
#end