% //////////////////////////////////////////////////////////
% //
% // synthetic test scenes for
% // structured light survey
% // 
% // christoph schmalz
% // 2009
% //
% // christoph(a)structuredlightsurvey.de
% //
% //////////////////////////////////////////////////////////
% //
% // version 1.0 - first public release
% //
% //////////////////////////////////////////////////////////
% //
% // adds minimal smoothing and different levels of noise
% // to the otherwise too perfect raytraced images
% //
% //////////////////////////////////////////////////////////

function loadImagesAndAddNoise(indir,outdir)

if nargin<2
    outdir = indir;
end
    
files = dir(indir);
variances = [1e-4, 1e-3, 1e-2]';

for f = 1:size(files,1)
    inname = fullfile(indir, files(f).name );

    if isdir(inname)
        continue;
    end

    [pathstr, name, ext, versn] = fileparts(inname);

    if ~strcmp(ext,'.bmp') && ~strcmp(ext,'.png')
        continue;
    end
    
    image = imread(inname);
    image2 = imfilter(image, fspecial('gaussian', [5 5], 0.5) );
    image2 = image;

    for idx=1:size(variances)
        outname = fullfile(outdir, sprintf('%s_noisy%d%s',name,idx,ext) );
        noisy = imnoise(image2,'gaussian',0,variances(idx));
        imwrite(noisy,outname);
    end
end