//////////////////////////////////////////////////////////
//
// synthetic test scenes for
// structured light survey
// 
// christoph schmalz
// 2009
//
// christoph(a)structuredlightsurvey.de
//
//////////////////////////////////////////////////////////
//
// version 1.0 - first public release
//
//////////////////////////////////////////////////////////
//
// different materials
//
//////////////////////////////////////////////////////////

//watch out, normal maps simulate depth where there is none
//so the visual impression will not be consistent with the ground truth depth map

//since povray does not yet do displacement mapping the way
//to generate true rough objects is isosurfaces

#declare material0 = //gray
material {
	texture {
		pigment { color rgb 0.6 }
		finish { ambient 0.2 diffuse 0.5 specular 0.1 conserve_energy }
		}
}

//----------------------------------------------------------------

#declare material1 = //white
material {
    texture { pigment {rgb 1}
			    finish { ambient 0.2 diffuse 0.5 specular 0.1 conserve_energy }
			 }
}

//----------------------------------------------------------------

#declare material2 = //almost black
material {
    texture { pigment {rgb 0.01}
			    finish { ambient 0.2 diffuse 0.5 specular 0.1 conserve_energy }
			 }
}

//----------------------------------------------------------------

#include "golds.inc"
#declare material3 = //gold metal
material {
    texture { T_Gold_3C }
}

//----------------------------------------------------------------

#include "metals.inc"
#declare material4 = //silver metal
material {
    texture { T_Silver_4A }
}

//----------------------------------------------------------------

#declare material5 = //jade? translucent volume scatterer
material{
    texture{
     pigment{rgbt <1,0.97,0.92,1>}
     finish{
         diffuse 1.0
         ambient 0
         specular 0.5
         roughness 0.01
     }
 }
 interior{
  ior 2.0
  media{
   #declare col = <.78,.74,.7>;
   #declare sc = 150;
   #declare ex = 0.8;
    scattering {5, rgb ((1-col)+<0,0,0>)*sc extinction ex eccentricity 0}
    emission <3,3,3>
    absorption (<2,2.3,2.6>)
    intervals 1
    samples 100
    method 3
  }
}
}

//----------------------------------------------------------------

#include "colors.inc"
#include "stones1.inc"
#declare material6 =
material{
	texture { T_Stone15 scale 0.1
		    normal { granite 0.1 scale 0.3 }
		    finish { ambient 0.2 diffuse 0.5 specular 0.1 }
	}
}

//----------------------------------------------------------------
